//+------------------------------------------------------------------+
//|                                              TRADE_FUNCTIONS.mqh |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|      ר         |
//+------------------------------------------------------------------+ 
struct STV
  {
   int
   dgt,             //    
   spread,          //    ask  bid
   stp_lvl,         //   stop level
   Leverage,        //   
   TRADE_EXEMODE,   //   
   TRADE_CALC_MODE; //    
   //---
   double
   pnt,             //   
   ask,             //  ask
   bid,             //  bid
   //---
   vol_stp,         //       
   vol_min,         //      
   vol_max,         //      
   vol_lmt,         //      
   //---
   fltr,            //  +/-   
   up_lvl,          //    stop level
   dw_lvl,          //    stop level
   //---
   tick_sz,         //   
   tick_loss,       //     
   tick_prft;       //     
  };
//---
STV SS;
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void Get_STV()
  {
   SS.dgt=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
   SS.spread=(int)SymbolInfoInteger(_Symbol,SYMBOL_SPREAD);
   SS.stp_lvl=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);
   SS.Leverage=(int)AccountInfoInteger(ACCOUNT_LEVERAGE);
   SS.TRADE_EXEMODE=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_EXEMODE);
   SS.TRADE_CALC_MODE=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_CALC_MODE);
//---
   SS.pnt=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
   SS.ask=ND_dgt(SymbolInfoDouble(_Symbol,SYMBOL_ASK),SS.dgt);
   SS.bid=ND_dgt(SymbolInfoDouble(_Symbol,SYMBOL_BID),SS.dgt);
//---
   SS.vol_stp=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
   SS.vol_min=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
   SS.vol_max=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);
   SS.vol_lmt=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_LIMIT);
//---
   SS.fltr=ND_dgt(vDgtMlt(3*SS.pnt),SS.dgt);
   SS.up_lvl=ND_dgt(SS.ask+SS.stp_lvl*SS.pnt,SS.dgt);
   SS.dw_lvl=ND_dgt(SS.bid-SS.stp_lvl*SS.pnt,SS.dgt);
//---
   SS.tick_sz=SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_SIZE);
   SS.tick_loss=SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE_LOSS);
   SS.tick_prft=SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE_PROFIT);
  }
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+
void TradingBlock()
  {
   int sign=-1;
   double
   lt=0.0,
   pb_tp=0.0,ps_tp=0.0,
   pb_sl=0.0,ps_sl=0.0;
//---
   ENUM_POSITION_TYPE pos_type=NULL;
//---
   Get_STV(); //    
//---
   sign=GetTradingSignal(0,3); //    /  
//---
   isPos=PositionSelect(_Symbol); //   / 
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
   if(sign==0)
     {
      //    Stop Loss  Take Profit
      ps_sl=GetLevelStopLoss(POSITION_TYPE_SELL,SS.bid);
      ps_tp=GetLevelTakeProfit(POSITION_TYPE_SELL,SS.bid);
      //---
      //   ,  
      if(!isPos)
        {
         lt=NormalizeDouble(gLot,2);
         OpenPosition(lt,ORDER_TYPE_SELL,SS.bid,ps_sl,ps_tp,"");
        }
      else //   
        {
         //   
         pos_type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);
         //---
         //   BUY   
         if(pos_type==POSITION_TYPE_BUY && gReverse)
           {
            lt=NormalizeDouble(gLot*2,2);
            OpenPosition(lt,ORDER_TYPE_SELL,SS.ask,ps_sl,ps_tp,"");
           }
        }
     }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
   if(sign==1)
     {
      //    Stop Loss  Take Profit
      pb_sl=GetLevelStopLoss(POSITION_TYPE_BUY,SS.ask);
      pb_tp=GetLevelTakeProfit(POSITION_TYPE_BUY,SS.ask);
      //---
      //   ,  
      if(!isPos)
        {
         OpenPosition(gLot,ORDER_TYPE_BUY,SS.ask,pb_sl,pb_tp,"");
        }
      else //   
        {
         //   
         pos_type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);
         //---
         //   SELL   
         if(pos_type==POSITION_TYPE_SELL && gReverse)
           {
            lt=NormalizeDouble(gLot*2,2);
            OpenPosition(lt,ORDER_TYPE_BUY,SS.bid,pb_sl,pb_tp,"");
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| T                                                 |
//+------------------------------------------------------------------+
void OpenPosition(double lots,
                  ENUM_ORDER_TYPE op_type,
                  double op_prc,
                  double sl_prc,
                  double tp_prc,
                  string nm_opr)
  {
   mytrade.SetExpertMagicNumber(0); //      
   mytrade.SetDeviationInPoints(100); //     
//---
//  
   if(!mytrade.PositionOpen(_Symbol,op_type,lots,op_prc,sl_prc,tp_prc,nm_opr))
     {
      Print("    : ",Error()," - ",ErrorDesc(Error()));
     }
  }
//+------------------------------------------------------------------+
//|   TAKEPROFIT                                    |
//+------------------------------------------------------------------+
double GetLevelTakeProfit(int type_pos,double level)
  {
   double tp=0.0;
//---
   if(type_pos==1) //  SELL (1)
     {
      //  Take Profit 
      if(gTakeProfit>0)
        {
         //  
         tp=ND_dgt(level-vDgtMlt((int)gTakeProfit)*SS.pnt,SS.dgt);
         //---
         //      (stop level)   
         if(tp<SS.dw_lvl) { return(tp); }
         else //     ,   
           { tp=SS.dw_lvl-SS.fltr; return(tp); }
        }
     }
//---
   if(type_pos==0) //  BUY (0)
     {
      //  Take Profit 
      if(gTakeProfit>0)
        {
         //  
         tp=ND_dgt(level+vDgtMlt((int)gTakeProfit)*SS.pnt,SS.dgt);
         //---
         //      (stop level)   
         if(tp>SS.up_lvl) { return(tp); }
         else //     ,   
           { tp=SS.up_lvl+SS.fltr; return(tp); }
        }
     }
//---
   return(0.0);
  }
//+------------------------------------------------------------------+
//|   STOPLOSS                                      |
//+------------------------------------------------------------------+
double GetLevelStopLoss(int type_pos,double level)
  {
   double sl=0.0;
//---
   if(type_pos==1) //  SELL (1)
     {
      //  Stop Loss 
      if(gStopLoss>0)
        {
         //  
         sl=ND_dgt(level+vDgtMlt((int)gStopLoss)*SS.pnt,SS.dgt);
         //---
         //      (stop level)   
         if(sl>SS.up_lvl) { return(sl); }
         else //     ,   
           { sl=SS.up_lvl+SS.fltr; return(sl); }
        }
     }
//---
   if(type_pos==0) //  BUY (0)
     {
      //  Stop Loss 
      if(gStopLoss>0)
        {
         //  
         sl=ND_dgt(level-vDgtMlt((int)gStopLoss)*SS.pnt,SS.dgt);
         //---
         //      (stop level)   
         if(sl<SS.dw_lvl) { return(sl); }
         else //     ,   
           { sl=SS.dw_lvl-SS.fltr; return(sl); }
        }
     }
//---
   return(0.0);
  }
//+------------------------------------------------------------------+
