//+------------------------------------------------------------------+
//|                                                     OnTheFly.mq5 |
//|            Copyright 2012, https://login.mql5.com/ru/users/tol64 |
//|                                        http://tol64.blogspot.com |
//+------------------------------------------------------------------+ 
#property copyright   "Copyright 2012, http://tol64.blogspot.com"
#property link        "http://tol64.blogspot.com"
#property description "email: hello.tol64@gmail.com"
#property version     "1.00"
//---
#define szArrIP 5 //   
#define NAME_EXPERT MQL5InfoString(MQL5_PROGRAM_NAME) //  
#define TRM_DP TerminalInfoString(TERMINAL_DATA_PATH) // ,     
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
#include <Trade/SymbolInfo.mqh>
#include <Trade/Trade.mqh>
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
#include "Include/!OnChartEvent.mqh"
#include "Include/CREATE_PANEL.mqh"
#include "Include/FILE_OPERATIONS.mqh"
#include "Include/ERRORS.mqh"
#include "Include/ARRAYS.mqh"
#include "Include/TRADE_SIGNALS.mqh"
#include "Include/TRADE_FUNCTIONS.mqh"
#include "Include/GET_STRING.mqh"
#include "Include/GET_COLOR.mqh"
#include "Include/ADD_FUNCTIONS.mqh"
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
CSymbolInfo mysymbol; //   CSymbolInfo
CTrade      mytrade;  //   CTrade
//+------------------------------------------------------------------+
//| _                                                |
//+------------------------------------------------------------------+
input int    Period_Ind      = 10;    // Indicator Period
input double TakeProfit      = 100;   // Take Profit (p)
input double StopLoss        = 30;    // Stop Loss (p)
input bool   Reverse         = false; // Reverse Position
input double Lot             = 0.1;   // Lot
//---
input string slash="";       // * * * * * * * * * * * * * * * * * * *
sinput bool  InfoPanel       = true;  // On/Off Info Panel
sinput bool  SettingOnTheFly = false; // Setting "On The Fly"
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
int hdlSI=INVALID_HANDLE; //   
double lcheck=0; //    
bool isPos=false; //  
//---   
int    gPeriod_Ind = 0;
double gTakeProfit = 0.0;
double gStopLoss   = 0.0;
bool   gReverse    = false;
double gLot        = 0.0;
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void OnInit()
  {
   if(NotTest()) { EventSetTimer(1); } //  
//---
   Init_arr_vparams(); //    
   SetParameters(); //  
   GetIndicatorsHandles(); //   
   NewBar(); //   
   SetInfoPanel(); //  
  }
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
void OnTick()
  {
//    , 
   if(!NewBar()) { return; }
   else
     { TradingBlock(); }
  }
//+------------------------------------------------------------------+
//|                                                            |
//+------------------------------------------------------------------+
void OnTimer()
  {
   SetParameters(); SetInfoPanel();
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//    
   if(NotTest())
     { Print(getUnitReasonText(reason)); }
//---
//    
   if(reason==REASON_REMOVE)
     {
      //     
      DeleteAllExpertObjects();
      //---
      if(NotTest()) { EventKillTimer(); } //  
      IndicatorRelease(hdlSI); //   
     }
  }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void GetIndicatorsHandles()
  {
   hdlSI=iCustom(_Symbol,_Period,"JMA.ex5",gPeriod_Ind,0);
//---
   if(hdlSI!=INVALID_HANDLE)
     { Print(__FUNCTION__,":     ("+IS(hdlSI)+")  "+_Symbol+""); }
   else
     { Print(__FUNCTION__,":        "+_Symbol+""); }
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
bool NewBar()
  {
   static datetime NewBar=NULL;
   static datetime lastbar_time[1]={0};
//---
//   
   if(CopyTime(_Symbol,_Period,0,1,lastbar_time)==-1)
     { Print(__FUNCTION__,":      : "+IS(Error())+""); }
//---
   if(NewBar==0) //     
     {
      NewBar=lastbar_time[0]; //     
      Print(__FUNCTION__,":  ["+_Symbol+"][TF: "+TFtoS(_Period)+"]["+TSdms(lastbar_time[0])+"]");
      return(false);
     }
//---
//   
   if(NewBar!=lastbar_time[0])
     {
      NewBar=lastbar_time[0]; //     
      return(true); //     true
     }
//---
   return(false); //     -    ,  false
  }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
//      false,       ,
//          .
//       .
bool flgRead=false;
double arrParamIP[]; // ,      
//---
void SetParameters()
  {
//     
//  -,      " "
   if(!NotTest() || (NotTest() && !SettingOnTheFly))
     {
      //     
      flgRead=false;
      ArrayResize(arrParamIP,0);
      //---
      //      
      if(Period_Ind<=0)
        { lcheck=10; }
      else { lcheck=Period_Ind; }
      gPeriod_Ind=(int)lcheck;
      //---
      gStopLoss=StopLoss;
      gTakeProfit=TakeProfit;
      gReverse=Reverse;
      //---
      //      ()
      if(Lot<=0)
        { lcheck=0.1; }
      else { lcheck=Lot; }
      gLot=lcheck;
     }
   else //     " "
     {
      // ,     /  / 
      string lpath="";
      //---
      //   
      if((lpath=CheckCreateGetPath())!="")
        {
         //    
         WriteReadParameters(lpath);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
void iZeroMemory()
  {
   flgDialogWin=false;
   ArrayResize(lenum,0);
   ArrayResize(lenmObj,0);
   number=-1; flgRead=false;
  }
//+------------------------------------------------------------------+
